#include "config.h"
#include "qspi.h"
#include "w25qxx.h"
#include "lcm.h"
#include "tft.h"
#include "usbcdc.h"
#include "timer.h"

#define DMA_AMT_LEN         (51200UL)
#define DMA_CNT             (IMG_SIZE / DMA_AMT_LEN)

void QSPI2TFT_Start();
void QSPI2TFT_Next();

typedef struct
{
    char strSign[4];
    DWORD dwCount;
    DWORD dwAddress[62];
} FAT;

FAT     Fat;                            //ļ
DWORD   dwOffset;                       //ͼƬݵƫƵַ
int     nIndex;                         //ͼƬ
int     nCount;                         //ͼƬװش
BOOL    fLoading;                       //װݱ־

void main()
{
    P_SW2 = 0x80;
    WTST = 0x00;
    CKCON = 0x00;

    P0M0 = 0x00; P0M1 = 0x00;
    P1M0 = 0x00; P1M1 = 0x00;
    P2M0 = 0x00; P2M1 = 0x00;
    P3M0 = 0x00; P3M1 = 0x00;
    P4M0 = 0x00; P4M1 = 0x00;
    P5M0 = 0x00; P5M1 = 0x00;
    
    TIMER0_Init();
    QSPI_Init();
    LCM_Init();
    TFT_Init();
    
    EA = 1;

    W25Q_Enable_QE();                   //ʹQSPI FLASH4߶дģʽ
    
    if (!P33)                           //סP3.3λ,ͼƬģʽ
    {
        CDC_Init();
        CDC_WaitStable();               //ȴUSB-CDC
        while (1)
        {
            CDC_Process();              //CDCӿڴͼƬ
        }
    }
    
    W25Q_FastRead_6B(0, (BYTE *)&Fat, 256);     //FLASHһҳȡFAT
    
    nIndex = 0;                         //ӵһͼƬʼʾ
    while (1)
    {
        if (f100ms)
        {
            f100ms = 0;
            
            QSPI2TFT_Start();           //ÿ100msԶʾһͼƬ
        }
    }
}

void QSPI_DMA_Isr() interrupt DMA_QSPI_VECTOR
{
    DMA_QSPI_STA = 0x00;
    QSPI2TFT_Next();                    //DMAһ
}

void QSPI2TFT_Start()
{
    if (fLoading)                       //װͼƬ,˳
        return;

P07 = 0;
    if (nIndex >= Fat.dwCount)          //ͼƬﵽֵ
        nIndex = 0;                     //ӵһͼƬʼѭ

    dwOffset = Fat.dwAddress[nIndex++]; //ȡǰͼƬƫƵַ
    nCount = 0;                         //ʼͼƬװش
    
    while (QSPI_CheckBusy());           //æ״̬
    QSPI_SetReadMode();                 //ģʽ
    QSPI_SetDataLength(DMA_AMT_LEN-1);  //ݳ
    QSPI_SetAddressSize(2);             //õַΪ24λ(2+1ֽ)
    QSPI_SetDummyCycles(8);             //DUMMYʱ
    QSPI_NoInstruction();               //ָģʽ(ֹ󴥷)
    QSPI_NoAddress();                   //޵ַģʽ(ֹ󴥷)
    QSPI_NoAlternate();                 //޼ֽ
    QSPI_DataQuadMode();                //Ϊģʽ
    QSPI_SetInstruction(0x6B);          //ָ
    QSPI_InstructionSingMode();         //ָΪģʽ
    QSPI_NoAddress();                   //޵ַģʽ(ֹ󴥷)
    QSPI_SetAddress(dwOffset);          //õַ
    QSPI_AddressSingMode();             //õַΪģʽ
                
    TFT_ShowStart();                    //ʼTFTʾ

    DMA_P2P_CR1 = 0x87;                 //P2P_SRC_QSPIRX(0x80) | P2P_DEST_LCMTX(0x07);
    DMA_QSPI_CFG = 0xa0;                //ʹDMAȡ
    DMA_QSPI_STA = 0x00;                //DMA״̬
    DMA_QSPI_AMT = (DMA_AMT_LEN-1);     //DMAݳ
    DMA_QSPI_AMTH = (DMA_AMT_LEN-1) >> 8;
    DMA_LCM_CR = 0xa0;
    DMA_QSPI_CR = 0xa1;                 //DMAQSPI
    
    fLoading = TRUE;
}

void QSPI2TFT_Next()
{
    dwOffset += DMA_AMT_LEN;            //ƫƵַ
    nCount++;                           //װش+1
    
    if (nCount < DMA_CNT)               //жͼƬװش
    {
        QSPI_NoAddress();               //޵ַģʽ(ֹ󴥷)
        QSPI_SetAddress(dwOffset);      //õַ
        QSPI_AddressSingMode();         //õַΪģʽ
        
        DMA_QSPI_CR = 0xa1;             //DMAQSPI
    }
    else
    {
        fLoading = FALSE;               //ͼƬװ
        DMA_QSPI_CR = 0x00;             //ֹͣQSPI_DMA
        DMA_QSPI_CFG = 0x00;
        DMA_LCM_CR = 0x00;
        DMA_P2P_CR1 = 0x00;
        
P07 = 1;
        TFT_ShowEnd();                  //TFTʾ
    }
}
