#ifndef __TFT_H__
#define __TFT_H__

#define HORIZONTAL

#define ILI9325             9325
#define ILI9486             9486

#define TFT_MODEL           ILI9486

#if (TFT_MODEL == ILI9325)

    #define TFT_W           240
    #define TFT_H           320

#elif (TFT_MODEL == ILI9486)

    #ifdef HORIZONTAL
        #define TFT_W       480
        #define TFT_H       320
    #else
        #define TFT_W       320
        #define TFT_H       480
    #endif

#endif

#define IMG_SIZE            ((DWORD)TFT_W * TFT_H * 2)


void TFT_WriteReg(BYTE reg);
void TFT_WriteData(BYTE dat);
void TFT_WriteDataW(WORD dat);

void TFT_Reset();
void TFT_Init();
void TFT_ShowStart();
void TFT_ShowData(BYTE dat);
void TFT_ShowDataW(WORD dat);
void TFT_ShowEnd();

#endif
